searchData={"items":[{"type":"module","title":"Membrane.RTMPServer","doc":"A simple RTMP server, which handles each new incoming connection. When a new client connects, the `handle_new_client` is invoked.\nNew connections remain in an incomplete RTMP handshake state, until another process makes demand for their data.\nIf no data is demanded within the client_timeout period, TCP socket is closed.\n\nOptions:\n- handle_new_client: An anonymous function called when a new client connects.\n    It receives the client reference, `app` and `stream_key`, allowing custom processing,\n    like sending the reference to another process. The function should return a `t:Membrane.RTMPServer.client_behaviour_spec/0`\n    which defines how the client should behave.\n- port: Port on which RTMP server will listen. Defaults to 1935.\n- use_ssl?: If true, SSL socket (for RTMPS) will be used. Othwerwise, TCP socket (for RTMP) will be used. Defaults to false.\n- client_timeout: Time after which an unused client connection is automatically closed, expressed in `Membrane.Time.t()` units. Defaults to 5 seconds.\n- name: If not nil, value of this field will be used as a name under which the server's process will be registered. Defaults to nil.","ref":"Membrane.RTMPServer.html"},{"type":"function","title":"Membrane.RTMPServer.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Membrane.RTMPServer.html#child_spec/1"},{"type":"function","title":"Membrane.RTMPServer.get_port/1","doc":"Returns the port on which the server listens for connection.","ref":"Membrane.RTMPServer.html#get_port/1"},{"type":"function","title":"Membrane.RTMPServer.parse_url/1","doc":"Extracts ssl, port, app and stream_key from url.","ref":"Membrane.RTMPServer.html#parse_url/1"},{"type":"function","title":"Membrane.RTMPServer.start_link/1","doc":"Starts the RTMP server.","ref":"Membrane.RTMPServer.html#start_link/1"},{"type":"type","title":"Membrane.RTMPServer.client_behaviour_spec/0","doc":"A type representing how a client handler should behave.\nIf just a tuple is passed, the second element of that tuple is used as\nan input argument of the `c:Membrane.RTMPServer.ClientHandler.handle_init/1`. Otherwise, an empty\nmap is passed to the `c:Membrane.RTMPServer.ClientHandler.handle_init/1`.","ref":"Membrane.RTMPServer.html#t:client_behaviour_spec/0"},{"type":"type","title":"Membrane.RTMPServer.server_identifier/0","doc":"","ref":"Membrane.RTMPServer.html#t:server_identifier/0"},{"type":"type","title":"Membrane.RTMPServer.t/0","doc":"Defines options for the RTMP server.","ref":"Membrane.RTMPServer.html#t:t/0"},{"type":"behaviour","title":"Membrane.RTMPServer.ClientHandler","doc":"A behaviour describing the actions that might be taken by the client\nhandler in response to different events.","ref":"Membrane.RTMPServer.ClientHandler.html"},{"type":"function","title":"Membrane.RTMPServer.ClientHandler.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Membrane.RTMPServer.ClientHandler.html#child_spec/1"},{"type":"function","title":"Membrane.RTMPServer.ClientHandler.demand_data/2","doc":"Makes the client handler ask client for the desired number of buffers","ref":"Membrane.RTMPServer.ClientHandler.html#demand_data/2"},{"type":"callback","title":"Membrane.RTMPServer.ClientHandler.handle_connection_closed/1","doc":"Callback invoked when the socket connection is terminated. In normal\nconditions, `handle_delete_stream` is called before this one. If delete_stream\nis not called and connection_closed is, it might just mean that the\nconnection was lost (for instance when TCP socket is closed unexpectedly).\n\nIt is up to the users to determined how to handle it in their case.","ref":"Membrane.RTMPServer.ClientHandler.html#c:handle_connection_closed/1"},{"type":"callback","title":"Membrane.RTMPServer.ClientHandler.handle_data_available/2","doc":"The callback invoked when new piece of data is received from a given client.","ref":"Membrane.RTMPServer.ClientHandler.html#c:handle_data_available/2"},{"type":"callback","title":"Membrane.RTMPServer.ClientHandler.handle_delete_stream/1","doc":"Callback invoked when the RMTP stream is finished.","ref":"Membrane.RTMPServer.ClientHandler.html#c:handle_delete_stream/1"},{"type":"callback","title":"Membrane.RTMPServer.ClientHandler.handle_info/2","doc":"The callback invoked when the client handler receives a message\nthat is not recognized as an internal message of the client handler.","ref":"Membrane.RTMPServer.ClientHandler.html#c:handle_info/2"},{"type":"callback","title":"Membrane.RTMPServer.ClientHandler.handle_init/1","doc":"The callback invoked once the client handler is created.\nIt should return the initial state of the client handler.","ref":"Membrane.RTMPServer.ClientHandler.html#c:handle_init/1"},{"type":"callback","title":"Membrane.RTMPServer.ClientHandler.handle_metadata/2","doc":"The optional callback invoked when the client handler receives RTMP message with\nmetadata information (just like a resolution or a framerate of a video stream).\nThe following messages are considered the ones that contain metadata:\n1) OnMetaData\n2) SetDataFrame","ref":"Membrane.RTMPServer.ClientHandler.html#c:handle_metadata/2"},{"type":"type","title":"Membrane.RTMPServer.ClientHandler.state/0","doc":"Type representing the user defined state of the client handler.","ref":"Membrane.RTMPServer.ClientHandler.html#t:state/0"},{"type":"type","title":"Membrane.RTMPServer.ClientHandler.t/0","doc":"A type representing a module which implements `Membrane.RTMPServer.ClientHandler` behaviour.","ref":"Membrane.RTMPServer.ClientHandler.html#t:t/0"},{"type":"module","title":"Membrane.RTMP.Messages.Anonymous","doc":"A catch-all module for all the messages that don't have a dedicated module, eg. `onBWDone`, `onStatus`, `_result`.","ref":"Membrane.RTMP.Messages.Anonymous.html"},{"type":"type","title":"Membrane.RTMP.Messages.Anonymous.t/0","doc":"","ref":"Membrane.RTMP.Messages.Anonymous.html#t:t/0"},{"type":"module","title":"Membrane.RTMP.Messages.Connect","doc":"Defines the RTMP `connect` command.","ref":"Membrane.RTMP.Messages.Connect.html"},{"type":"function","title":"Membrane.RTMP.Messages.Connect.to_map/1","doc":"","ref":"Membrane.RTMP.Messages.Connect.html#to_map/1"},{"type":"type","title":"Membrane.RTMP.Messages.Connect.t/0","doc":"","ref":"Membrane.RTMP.Messages.Connect.html#t:t/0"},{"type":"module","title":"Membrane.RTMP.Messages.OnExpectAdditionalMedia","doc":"Defines the RTMP `onExpectAdditionalMedia` command that is related to Twitch's RTMP additional\nmedia track message.\n\nThe command is usually a part of `@setDataFrame` command but for more convencience it is\nextracted.","ref":"Membrane.RTMP.Messages.OnExpectAdditionalMedia.html"},{"type":"function","title":"Membrane.RTMP.Messages.OnExpectAdditionalMedia.new/1","doc":"","ref":"Membrane.RTMP.Messages.OnExpectAdditionalMedia.html#new/1"},{"type":"type","title":"Membrane.RTMP.Messages.OnExpectAdditionalMedia.t/0","doc":"","ref":"Membrane.RTMP.Messages.OnExpectAdditionalMedia.html#t:t/0"},{"type":"module","title":"Membrane.RTMP.Messages.OnMetaData","doc":"Defines the RTMP `onMetaData` command (sent by nginx client).","ref":"Membrane.RTMP.Messages.OnMetaData.html"},{"type":"function","title":"Membrane.RTMP.Messages.OnMetaData.new/1","doc":"","ref":"Membrane.RTMP.Messages.OnMetaData.html#new/1"},{"type":"type","title":"Membrane.RTMP.Messages.OnMetaData.t/0","doc":"","ref":"Membrane.RTMP.Messages.OnMetaData.html#t:t/0"},{"type":"module","title":"Membrane.RTMP.Messages.Publish","doc":"Defines the RTMP `publish` command.","ref":"Membrane.RTMP.Messages.Publish.html"},{"type":"type","title":"Membrane.RTMP.Messages.Publish.t/0","doc":"","ref":"Membrane.RTMP.Messages.Publish.html#t:t/0"},{"type":"module","title":"Membrane.RTMP.Messages.ReleaseStream","doc":"Defines the RTMP `releaseStream` command.","ref":"Membrane.RTMP.Messages.ReleaseStream.html"},{"type":"type","title":"Membrane.RTMP.Messages.ReleaseStream.t/0","doc":"","ref":"Membrane.RTMP.Messages.ReleaseStream.html#t:t/0"},{"type":"module","title":"Membrane.RTMP.Messages.SetDataFrame","doc":"Defines the RTMP `setDataFrame` command.","ref":"Membrane.RTMP.Messages.SetDataFrame.html"},{"type":"function","title":"Membrane.RTMP.Messages.SetDataFrame.new/1","doc":"","ref":"Membrane.RTMP.Messages.SetDataFrame.html#new/1"},{"type":"type","title":"Membrane.RTMP.Messages.SetDataFrame.t/0","doc":"","ref":"Membrane.RTMP.Messages.SetDataFrame.html#t:t/0"},{"type":"module","title":"Membrane.RTMP.Sink","doc":"Membrane element being client-side of RTMP streams.\nIt needs to receive at least one of: video stream in H264 format or audio in AAC format.\nCurrently it supports only:\n  - RTMP proper - \"plain\" RTMP protocol\n  - RTMPS - RTMP over TLS/SSL\nother RTMP variants - RTMPT, RTMPE, RTMFP are not supported.\nImplementation based on FFmpeg.","ref":"Membrane.RTMP.Sink.html"},{"type":"module","title":"Element options - Membrane.RTMP.Sink","doc":"Passed via struct `t:Membrane.RTMP.Sink.t/0`\n\n- `rtmp_url`  \n\n  ```\n  String.t()\n  ```\n  \n  ***Required***  \n  Destination URL of the stream. It needs to start with rtmp:// or rtmps:// depending on the protocol variant.\n  This URL should be provided by your streaming service.\n\n\n- `max_attempts`  \n\n  ```\n  pos_integer() | :infinity\n  ```\n  \n  Default value: `1`  \n  Maximum number of connection attempts before failing with an error.\n  The attempts will happen every 500 ms\n\n\n\n- `tracks`  \n\n  ```\n  [track_type()]\n  ```\n  \n  Default value: `[:audio, :video]`  \n  A list of tracks, which will be sent. Can be `:audio`, `:video` or both.\n\n\n\n- `reset_timestamps`  \n\n  ```\n  boolean()\n  ```\n  \n  Default value: `true`  \n  If enabled, this feature adjusts the timing of outgoing FLV packets so that they begin from zero.\n  Leaves it untouched otherwise.","ref":"Membrane.RTMP.Sink.html#module-element-options"},{"type":"module","title":"Pads - Membrane.RTMP.Sink","doc":"### `:video`\n\nAccepted formats:\n```\n%H264{stream_structure: structure} when H264.is_avc(structure)\n```\n\nDirection: | `:input`\nAvailability: | `:on_request`\nFlow control: | `:manual`\nDemand unit: | `:buffers`\n\n\n### `:audio`\n\nAccepted formats:\n```\nAAC\n```\n\nDirection: | `:input`\nAvailability: | `:on_request`\nFlow control: | `:manual`\nDemand unit: | `:buffers`","ref":"Membrane.RTMP.Sink.html#module-pads"},{"type":"function","title":"Membrane.RTMP.Sink.options/0","doc":"Returns description of options available for this module","ref":"Membrane.RTMP.Sink.html#options/0"},{"type":"type","title":"Membrane.RTMP.Sink.t/0","doc":"Struct containing options for `Membrane.RTMP.Sink`","ref":"Membrane.RTMP.Sink.html#t:t/0"},{"type":"type","title":"Membrane.RTMP.Sink.track_type/0","doc":"","ref":"Membrane.RTMP.Sink.html#t:track_type/0"},{"type":"module","title":"Membrane.RTMP.Source","doc":"Membrane Element for receiving an RTMP stream. Acts as a RTMP Server.\nThis implementation is limited to only AAC and H264 streams.\n\nThe source can be used in the following two scenarios:\n* by providing the URL on which the client is expected to connect - note, that if the client doesn't\nconnect on this URL, the source won't complete its setup. Note that all attempted connections to\nother `app` or `stream_key` than specified ones will be rejected.\n\n* by spawning `Membrane.RTMPServer`, receiving a client reference and passing it to the `Membrane.RTMP.Source`.","ref":"Membrane.RTMP.Source.html"},{"type":"module","title":"Element options - Membrane.RTMP.Source","doc":"Passed via struct `t:Membrane.RTMP.Source.t/0`\n\n- `client_ref`  \n\n  ```\n  pid()\n  ```\n  \n  Default value: `nil`  \n  A pid of a process acting as a client reference.\n  Can be gained with the use of `Membrane.RTMPServer`.\n\n\n- `url`  \n\n  ```\n  String.t()\n  ```\n  \n  Default value: `nil`  \n  An URL on which the client is expected to connect, for example:\n  rtmp://127.0.0.1:1935/app/stream_key\n\n\n\n- `client_timeout`  \n\n  ```\n  Membrane.Time.t()\n  ```\n  \n  Default value: `5000000000`  \n  Time after which an unused client connection is automatically closed, expressed in `Membrane.Time.t()` units. Defaults to 5 seconds.","ref":"Membrane.RTMP.Source.html#module-element-options"},{"type":"module","title":"Pads - Membrane.RTMP.Source","doc":"### `:output`\n\nAccepted formats:\n```\nMembrane.RemoteStream\n```\n\nDirection: | `:output`\nAvailability: | `:always`\nFlow control: | `:manual`\nDemand unit: | `:buffers`","ref":"Membrane.RTMP.Source.html#module-pads"},{"type":"function","title":"Membrane.RTMP.Source.options/0","doc":"Returns description of options available for this module","ref":"Membrane.RTMP.Source.html#options/0"},{"type":"type","title":"Membrane.RTMP.Source.t/0","doc":"Struct containing options for `Membrane.RTMP.Source`","ref":"Membrane.RTMP.Source.html#t:t/0"},{"type":"module","title":"Membrane.RTMP.Source.ClientHandlerImpl","doc":"An implementation of `Membrane.RTMPServer.ClienHandlerBehaviour` compatible with the\n`Membrane.RTMP.Source` element.","ref":"Membrane.RTMP.Source.ClientHandlerImpl.html"},{"type":"module","title":"Membrane.RTMP.SourceBin","doc":"Bin responsible for demuxing and parsing an RTMP stream.\n\nOutputs single audio and video which are ready for further processing with Membrane Elements.\nAt this moment only AAC and H264 codecs are supported.\n\nThe bin can be used in the following two scenarios:\n* by providing the URL on which the client is expected to connect - note, that if the client doesn't\nconnect on this URL, the bin won't complete its setup\n* by spawning `Membrane.RTMPServer`, receiving client reference after client connects on a given `app` and `stream_key`\nand passing the client reference to the `Membrane.RTMP.SourceBin`.","ref":"Membrane.RTMP.SourceBin.html"},{"type":"module","title":"Bin options - Membrane.RTMP.SourceBin","doc":"Passed via struct `t:Membrane.RTMP.SourceBin.t/0`\n\n- `client_ref`  \n\n  ```\n  pid()\n  ```\n  \n  Default value: `nil`  \n  A pid of a process acting as a client reference.\n  Can be gained with the use of `Membrane.RTMPServer`.\n\n\n- `url`  \n\n  ```\n  String.t()\n  ```\n  \n  Default value: `nil`  \n  An URL on which the client is expected to connect, for example:\n  rtmp://127.0.0.1:1935/app/stream_key\n\n\n\n- `client_timeout`  \n\n  ```\n  Membrane.Time.t()\n  ```\n  \n  Default value: `5000000000`  \n  Time after which an unused client connection is automatically closed, expressed in `Membrane.Time.t()` units. Defaults to 5 seconds.","ref":"Membrane.RTMP.SourceBin.html#module-bin-options"},{"type":"module","title":"Pads - Membrane.RTMP.SourceBin","doc":"### `:audio`\n\nAccepted formats:\n```\nAAC\n```\n\nDirection: | `:output`\nAvailability: | `:on_request`\n\n\n### `:video`\n\nAccepted formats:\n```\nH264\n```\n\nDirection: | `:output`\nAvailability: | `:on_request`","ref":"Membrane.RTMP.SourceBin.html#module-pads"},{"type":"function","title":"Membrane.RTMP.SourceBin.options/0","doc":"Returns description of options available for this module","ref":"Membrane.RTMP.SourceBin.html#options/0"},{"type":"function","title":"Membrane.RTMP.SourceBin.pass_control/2","doc":"Passes the control of the socket to the `source`.\n\nTo succeed, the executing process must be in control of the socket, otherwise `{:error, :not_owner}` is returned.","ref":"Membrane.RTMP.SourceBin.html#pass_control/2"},{"type":"function","title":"Membrane.RTMP.SourceBin.secure_pass_control/2","doc":"Passes the control of the ssl socket to the `source`.\n\nTo succeed, the executing process must be in control of the socket, otherwise `{:error, :not_owner}` is returned.","ref":"Membrane.RTMP.SourceBin.html#secure_pass_control/2"},{"type":"type","title":"Membrane.RTMP.SourceBin.t/0","doc":"Struct containing options for `Membrane.RTMP.SourceBin`","ref":"Membrane.RTMP.SourceBin.html#t:t/0"},{"type":"extras","title":"Membrane RTMP Plugin","doc":"# Membrane RTMP Plugin\n\n[![Hex.pm](https://img.shields.io/hexpm/v/membrane_rtmp_plugin.svg)](https://hex.pm/packages/membrane_rtmp_plugin)\n[![API Docs](https://img.shields.io/badge/api-docs-yellow.svg?style=flat)](https://hexdocs.pm/membrane_rtmp_plugin)\n[![CircleCI](https://circleci.com/gh/membraneframework/membrane_rtmp_plugin.svg?style=svg)](https://circleci.com/gh/membraneframework/membrane_rtmp_plugin)\n\nThis package provides RTMP server which receives an RTMP stream from a client and an element for streaming to an RTMP server.\nIt is a part of [Membrane Multimedia Framework](https://membraneframework.org).","ref":"readme.html"},{"type":"extras","title":"Installation - Membrane RTMP Plugin","doc":"The package can be installed by adding `membrane_rtmp_plugin` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n\t  {:membrane_rtmp_plugin, \"~> 0.28.0\"}\n  ]\nend\n```\n\nThe precompiled builds of the [ffmpeg](https://www.ffmpeg.org) will be pulled and linked automatically. However, should there be any problems, consider installing it manually.","ref":"readme.html#installation"},{"type":"extras","title":"Manual instalation of dependencies - Membrane RTMP Plugin","doc":"#### macOS\n\n```shell\nbrew install ffmpeg\n```\n\n#### Ubuntu\n\n```shell\nsudo apt-get install ffmpeg\n```\n\n#### Arch / Manjaro\n\n```shell\npacman -S ffmpeg\n```","ref":"readme.html#manual-instalation-of-dependencies"},{"type":"extras","title":"RTMP Server - Membrane RTMP Plugin","doc":"An simple RTMP server that accepts clients connecting on a given port and allows to distinguish between them\nbased on app ID and stream key. Each client that has connected is asigned a dedicated client handler, which\nbehaviour can be provided by RTMP server user.","ref":"readme.html#rtmp-server"},{"type":"extras","title":"SourceBin - Membrane RTMP Plugin","doc":"Requires a client reference, which identifies a client handler that has been connected to the client, or an URL on which the client is supposed to connect. It receives RTMP stream, demuxes it and outputs H264 video and AAC audio.","ref":"readme.html#sourcebin"},{"type":"extras","title":"Client - Membrane RTMP Plugin","doc":"After establishing connection with server it waits to receive video and audio streams. Once both streams are received they are streamed to the server.\nCurrently only the following codecs are supported:\n\n- H264 for video\n- AAC for audio","ref":"readme.html#client"},{"type":"extras","title":"Prerequisites - Membrane RTMP Plugin","doc":"In order to successfully build and install the plugin, you need to have **ffmpeg == 4.4** installed on your system","ref":"readme.html#prerequisites"},{"type":"extras","title":"Usage - Membrane RTMP Plugin","doc":"","ref":"readme.html#usage"},{"type":"extras","title":"RTMP receiver - Membrane RTMP Plugin","doc":"Server-side example, in which Membrane element will act as an RTMP server and receive the stream, can be found under [`examples/source.exs`](examples/source.exs). Please note that\nthis script allows only for a single client connecting to the RTMP server.\nRun it with:\n\n```bash\nmix run examples/source.exs\n```\n\nWhen the server is ready you can connect to it with RTMP. If you just want to test it, you can use FFmpeg:\n\n```bash\nffmpeg -re -i test/fixtures/testsrc.flv -f flv -c:v copy -c:a copy rtmp://localhost:1935/app/stream_key\n```\nWhen the script terminates, the `testsrc` content should be available in the `received.flv` file.","ref":"readme.html#rtmp-receiver"},{"type":"extras","title":"RTMP receive with standalone RTMP server - Membrane RTMP Plugin","doc":"If you want to see how you could setup the `Membrane.RTMPServer` on your own and use it\nwith cooperation with the `Membane.RTMP.SourceBin`, take a look at [`examples/source_with_standalone_server.exs`](examples/source_with_standalone_server.exs)\nRun it with:\n\n```bash\nmix run examples/source.exs\n```\n\nWhen the server is ready you can connect to it with RTMP. If you just want to test it, you can use FFmpeg:\n\n```bash\nffmpeg -re -i test/fixtures/testsrc.flv -f flv -c:v copy -c:a copy rtmp://localhost:1935/app/stream_key\n```\nWhen the script terminates, the `testsrc` content should be available in the `received.flv` file.","ref":"readme.html#rtmp-receive-with-standalone-rtmp-server"},{"type":"extras","title":"Streaming with RTMP - Membrane RTMP Plugin","doc":"Streaming implementation example is provided with the following [`examples/sink.exs`](examples/sink.exs). Run it with:\n\n```bash\nelixir examples/sink.exs\n```\n\nIf you are interested in streaming only a single track. e.g. video, use [`examples/sink_video.exs`](examples/sink_video.exs) instead:\n\n```bash\nelixir examples/sink_video.exs\n```\n\nIt will connect to RTMP server provided via URL and stream H264 video and AAC audio.\nRTMP server that will receive this stream can be launched with ffmpeg by running the following commands:\n\n```bash\nffmpeg -y -listen 1 -f flv -i rtmp://localhost:1935 -c copy dest.flv\n```\n\nIt will receive stream and once streaming is completed dump it to .flv file. If you are using the command above, please remember to run it **before** the streaming script.","ref":"readme.html#streaming-with-rtmp"},{"type":"extras","title":"Copyright and License - Membrane RTMP Plugin","doc":"Copyright 2021, [Software Mansion](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=membrane_rtmp_plugin)\n\n[![Software Mansion](https://logo.swmansion.com/logo?color=white&variant=desktop&width=200&tag=membrane-github)](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=membrane_rtmp_plugin)\n\nLicensed under the [Apache License, Version 2.0](LICENSE)","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright 2020 Software Mansion\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}